=== debian/changelog ===
ros-galactic-uncrustify-vendor (1.5.3-2focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Michel Hidalgo <michel@ekumenlabs.com>  Tue, 20 Apr 2021 23:07:06 -0000
