=== debian/control ===
Source: ros-galactic-uncrustify-vendor
Section: misc
Priority: optional
Maintainer: Michel Hidalgo <michel@ekumenlabs.com>
Build-Depends: debhelper (>= 9.0.0), git, ros-galactic-ament-cmake, uncrustify, ros-galactic-ros-workspace
Homepage: https://github.com/uncrustify/uncrustify
Standards-Version: 3.9.2

Package: ros-galactic-uncrustify-vendor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, uncrustify, ros-galactic-ros-workspace
Description: Wrapper around uncrustify, providing nothing but a dependency on uncrustify, on some systems.
 On others, it provides an ExternalProject build of uncrustify.
